using System;
using System.Data;
using System.Collections.Generic;
using CallCenterApi.Model;
using CallCenter.Utility;

namespace CallCenterApi.BLL
{
    /// <summary>
    /// T_Sys_Department
    /// </summary>
    public partial class T_Sys_Department
    {
        private readonly CallCenterApi.DAL.T_Sys_Department dal = new CallCenterApi.DAL.T_Sys_Department();
        public T_Sys_Department()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_DeptId)
        {
            return dal.Exists(F_DeptId);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_Department model)
        {
            OutRedis();
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_Department model)
        {
            OutRedis();
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_DeptId)
        {
            OutRedis();
            return dal.Delete(F_DeptId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_DeptIdlist)
        {
            OutRedis();
            return dal.DeleteList(F_DeptIdlist);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool UpdateSMSList(string F_DeptIdlist,int state)
        {
            OutRedis();
            return dal.UpdateSMSList(F_DeptIdlist, state);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool UpdateSMS( int state)
        {
            OutRedis();
            return dal.UpdateSMS( state);
        }
        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_Department GetModel(int F_DeptId)
        {
            var dt = GetRedis();
            if (dt != null)
            {
                var dr = dt.Select("F_DeptId=" + F_DeptId);
                if (dr != null && dr.Length > 0)
                {
                    return dal.DataRowToModel(dr[0]);
                }
                else
                {
                    return null;
                }
            }
            else
            {
                return dal.GetModel(F_DeptId);
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere, string filedOrder = "")
        {
            var dt = GetRedis();
            if (dt != null)
            {
                var ds = new DataSet();

                var drs = dt.Select(strWhere, filedOrder);
                if (drs.Length > 0)
                {
                    ds.Tables.Add(drs.CopyToDataTable());
                }
                else
                {
                    ds.Tables.Add(new DataTable());
                }
                return ds;
            }
            else
            {
                return dal.GetList(strWhere);
            }

        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetListNoCache(string strWhere)
        {
            return dal.GetList(strWhere);
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Sys_Department> GetModelList(string strWhere, string filedOrder = "")
        {
            var dt = GetRedis();
            if (dt != null)
            {
                var dtnew = new DataTable();
                var drs = dt.Select(strWhere, filedOrder);
                if (drs.Length > 0)
                {
                    dtnew = drs.CopyToDataTable();
                }
                return DataTableToList(dtnew);
            }
            else
            {
                DataSet ds = dal.GetList(strWhere, filedOrder);
                return DataTableToList(ds.Tables[0]);
            }
        }
        /// <summary>
		/// 获得数据列表
		/// </summary>
		public List<CallCenterApi.Model.T_Sys_Department> GetModelListNoCache(string strWhere, string filedOrder)
        {
            DataSet ds = dal.GetList(strWhere, filedOrder);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Sys_Department> DataTableToList(DataTable dt)
        {
            List<CallCenterApi.Model.T_Sys_Department> modelList = new List<CallCenterApi.Model.T_Sys_Department>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                CallCenterApi.Model.T_Sys_Department model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        //public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        //{
        //return dal.GetList(PageSize,PageIndex,strWhere);
        //}

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod

        private DataTable GetRedis()
        {
            var strList = RedisHelper.StringGet("T_Sys_Department");
            if (strList != null)
            {
                return strList.ToString().ToObject<DataTable>();
            }
            else
            {
                return InRedis();
            }
        }

        private DataTable InRedis()
        {
            var dt = dal.GetList("").Tables[0];

            RedisHelper.StringSet("T_Sys_Department", dt.ToJson(), new TimeSpan(24, 0, 0));

            return dt;
        }

        private void OutRedis()
        {
            RedisHelper.KeyDelete("T_Sys_Department");
        }
    }
}

